unit ClientCOMClass;

interface

uses
  ComObj, ActiveX, Client_TLB;

type
  TInternalServer = class(TAutoObject, IInternalServer)
  protected
    function Get_CurrentDateAndTime: TDateTime; safecall;
  public
    procedure Initialize; override;
    destructor Destroy; override;
  end;

implementation

uses ComServ, SysUtils, Dialogs;

procedure TInternalServer.Initialize;
begin
  inherited;
  ShowMessage('Internal object created')
end;

destructor TInternalServer.Destroy;
begin
  ShowMessage('Internal object destroyed');
  inherited
end;

function TInternalServer.Get_CurrentDateAndTime: TDateTime;
begin
  Result := Now
end;

initialization
  TAutoObjectFactory.Create(ComServer, TInternalServer, Class_InternalServer, ciInternal);
end.
