unit Client_TLB;

{ This file contains pascal declarations imported from a type library.
  This file will be written during each import or refresh of the type
  library editor.  Changes to this file will be discarded during the
  refresh process. }

{ Client Library }
{ Version 1.0 }

interface

uses Windows, ActiveX, Classes, Graphics, OleCtrls, StdVCL;

const
  LIBID_Client: TGUID = '{92D58240-C014-11D1-96E6-444553540000}';

const

{ Component class GUIDs }
  Class_InternalServer: TGUID = '{92D58242-C014-11D1-96E6-444553540000}';

type

{ Forward declarations: Interfaces }
  IInternalServer = interface;
  IInternalServerDisp = dispinterface;

{ Forward declarations: CoClasses }
  InternalServer = IInternalServer;

{ Dispatch interface for InternalServer Object }

  IInternalServer = interface(IDispatch)
    ['{92D58241-C014-11D1-96E6-444553540000}']
    function Get_CurrentDateAndTime: TDateTime; safecall;
    property CurrentDateAndTime: TDateTime read Get_CurrentDateAndTime;
  end;

{ DispInterface declaration for Dual Interface IInternalServer }

  IInternalServerDisp = dispinterface
    ['{92D58241-C014-11D1-96E6-444553540000}']
    property CurrentDateAndTime: TDateTime readonly dispid 1;
  end;

{ InternalServerObject }

  CoInternalServer = class
    class function Create: IInternalServer;
    class function CreateRemote(const MachineName: string): IInternalServer;
  end;



implementation

uses ComObj;

class function CoInternalServer.Create: IInternalServer;
begin
  Result := CreateComObject(Class_InternalServer) as IInternalServer;
end;

class function CoInternalServer.CreateRemote(const MachineName: string): IInternalServer;
begin
  Result := CreateRemoteComObject(MachineName, Class_InternalServer) as IInternalServer;
end;


end.
